import { QueryList, AfterViewInit, OnDestroy, ElementRef, ChangeDetectorRef, OnChanges, SimpleChanges, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { DomSanitizer } from '@angular/platform-browser';
import { LyShadowService } from 'alyle-ui/shadow';
import { CarouselService, VibrantColors } from './carousel.service';
import { MinimalLS } from 'alyle-ui/ls';
export declare class LyCarousel implements ControlValueAccessor, AfterViewInit, OnDestroy {
    private elementRef;
    private shadow;
    private sanitizer;
    private cd;
    private platformId;
    data: any;
    value: any;
    _selectedIndex: any;
    _interval: number;
    _fnInterval: any;
    _isInitialized: boolean;
    nullImg: string;
    lyItems: QueryList<LyCarouselItemComponent>;
    _itemSelect: number;
    currentCarousel: LyCarouselItemComponent;
    currentColors: VibrantColors;
    /** Callback registered via registerOnTouched (ControlValueAccessor) */
    private _onTouchedCallback;
    /** Callback registered via registerOnChange (ControlValueAccessor) */
    private _onChangeCallback;
    constructor(elementRef: ElementRef, shadow: LyShadowService, sanitizer: DomSanitizer, cd: ChangeDetectorRef, platformId: Object);
    private sanitizerStyle(val);
    interval: number;
    registerOnChange(fn: any): void;
    readonly stateIndicator: number;
    readonly stylesBar: {
        animation: string;
    };
    registerOnTouched(fn: any): void;
    writeValue(value: any): void;
    ngOnDestroy(): void;
    _intervalCarousel(value?: any): void;
    setActiveItem(): void;
    _markForCheck(): void;
    ngAfterViewInit(): void;
    select(val: number): void;
    focusRight(): void;
    focusLeft(): void;
}
export declare class LyCarouselItemComponent implements OnInit, OnChanges {
    private carouselService;
    private ls;
    private cd;
    private platformId;
    src: string;
    lyCarouselActive: boolean;
    color: VibrantColors;
    private _carousel;
    constructor(carousel: LyCarousel, carouselService: CarouselService, ls: MinimalLS, cd: ChangeDetectorRef, platformId: Object);
    preloadImage(url: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    updateColors(): void;
    _markForCheck(): void;
}
