import { Injectable } from '@angular/core';
import { MinimalLS } from 'alyle-ui/ls';
export class VibrantSwatch {
}
export class VibrantColors {
    constructor() {
        this.Vibrant = new VibrantSwatch;
        this.DarkVibrant = new VibrantSwatch;
        this.DarkMuted = new VibrantSwatch;
        this.Muted = new VibrantSwatch;
        this.LightVibrant = new VibrantSwatch;
    }
}
export class CarouselService {
    constructor(ls) {
        this.ls = ls;
    }
    getColorVibrant(srcImg) {
        const v = new Vibrant(srcImg).getPalette();
        return v.then((pal) => {
            if (pal) {
                this.ls.setItem(srcImg, this._palette(pal));
            }
        });
    }
    /**
       * return Vibrant & DarkVibrant
       */
    _palette(pal) {
        const palette = {};
        for (const key in pal) {
            if (pal.hasOwnProperty(key)) {
                palette[`${key}`] = {
                    'bodyTextColor': pal[key].getBodyTextColor(),
                    'hex': pal[key].getHex(),
                    'titleTextColor': pal[key].getTitleTextColor(),
                    'yiq': pal[key].getYiq()
                };
            }
        }
        return palette;
    }
}
CarouselService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
CarouselService.ctorParameters = () => [
    { type: MinimalLS, },
];
//# sourceMappingURL=carousel.service.js.map