(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@angular/common'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.checkbox = {}),global.ng.core,global.ng.forms,global.ng.common));
}(this, (function (exports,core,forms,common) { 'use strict';

var LY_CHECKBOX_CONTROL_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return LyCheckbox; }),
    multi: true
};
(function (CheckboxState) {
    /** The initial state. */
    CheckboxState[CheckboxState["Init"] = 0] = "Init";
    /** Checked state. */
    CheckboxState[CheckboxState["Checked"] = 1] = "Checked";
    /** Unchecked state. */
    CheckboxState[CheckboxState["Unchecked"] = 2] = "Unchecked";
    /** Indeterminate state. */
    CheckboxState[CheckboxState["Indeterminate"] = 3] = "Indeterminate";
})(exports.CheckboxState || (exports.CheckboxState = {}));
var LyCheckbox = /** @class */ (function () {
    function LyCheckbox() {
        this._currentCheckState = exports.CheckboxState.Init;
        this.checked = false;
        this.change = new core.EventEmitter();
        this.indeterminateChange = new core.EventEmitter();
        this.onTouched = function () { };
        this._controlValueAccessorChangeFn = function (value) { };
    }
    /** Toggles the `checked` state of the checkbox. */
    /** Toggles the `checked` state of the checkbox. */
    LyCheckbox.prototype.toggle = /** Toggles the `checked` state of the checkbox. */
    function () {
        this.checked = !this.checked;
    };
    LyCheckbox.prototype._onChangeEvent = function (event) {
        event.stopPropagation();
    };
    LyCheckbox.prototype._onInputClick = function (event) {
        var ev = event.target;
        this.checked = ev.checked;
        this._controlValueAccessorChangeFn(this.checked);
        console.log('_onInputClick', ev.checked);
    };
    LyCheckbox.prototype.writeValue = function (value) {
        this.checked = !!value;
        console.log('value', this.checked);
    };
    LyCheckbox.prototype.registerOnChange = function (fn) {
        this._controlValueAccessorChangeFn = fn;
    };
    LyCheckbox.prototype.ngOnChanges = function (changes) {
        console.log('changes', changes);
        if (changes['src']) {
            // fn
        }
    };
    LyCheckbox.prototype.registerOnTouched = function (fn) {
        this.onTouched = fn;
    };
    LyCheckbox.prototype.ngOnInit = function () {
    };
    LyCheckbox.prototype.ngAfterContentInit = function () {
    };
    LyCheckbox.prototype.ngOnDestroy = function () {
    };
    LyCheckbox.decorators = [
        { type: core.Component, args: [{
                    selector: 'ly-checkbox',
                    template: "<label> <div class=\"ly-checkbox-container\"> <input #input [hidden]=\"false\" type=\"checkbox\" [id]=\"id\" [required]=\"required\" [checked]=\"checked\" [value]=\"value\" [disabled]=\"disabled\" [name]=\"name\" [indeterminate]=\"indeterminate\" [attr.aria-label]=\"ariaLabel\" [attr.aria-labelledby]=\"ariaLabelledby\" (change)=\"_onChangeEvent($event)\" (click)=\"_onInputClick($event)\"> </div> </label> ",
                    styles: [":host { display: inline-block; } "],
                    providers: [LY_CHECKBOX_CONTROL_VALUE_ACCESSOR]
                },] },
    ];
    /** @nocollapse */
    LyCheckbox.ctorParameters = function () { return []; };
    LyCheckbox.propDecorators = {
        "id": [{ type: core.Input, args: ['id',] },],
        "ariaLabel": [{ type: core.Input, args: ['attr.aria-label',] },],
        "ariaLabelledby": [{ type: core.Input, args: ['attr.aria-labelledby',] },],
        "required": [{ type: core.Input, args: ['required',] },],
        "labelPosition": [{ type: core.Input, args: ['labelPosition',] },],
        "color": [{ type: core.Input, args: ['color',] },],
        "value": [{ type: core.Input, args: ['value',] },],
        "name": [{ type: core.Input, args: ['name',] },],
        "disabled": [{ type: core.Input, args: ['disabled',] },],
        "checked": [{ type: core.Input, args: ['checked',] },],
        "indeterminate": [{ type: core.Input, args: ['indeterminate',] },],
        "change": [{ type: core.Output, args: ['change',] },],
        "indeterminateChange": [{ type: core.Output, args: ['indeterminateChange',] },],
    };
    return LyCheckbox;
}());

var LyCheckboxService = /** @class */ (function () {
    function LyCheckboxService() {
    }
    LyCheckboxService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    LyCheckboxService.ctorParameters = function () { return []; };
    return LyCheckboxService;
}());

var LyCheckboxModule = /** @class */ (function () {
    function LyCheckboxModule() {
    }
    LyCheckboxModule.forRoot = function () {
        return {
            ngModule: LyCheckboxModule,
        };
    };
    LyCheckboxModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule
                    ],
                    exports: [LyCheckbox],
                    declarations: [LyCheckbox],
                    providers: [LyCheckboxService]
                },] },
    ];
    /** @nocollapse */
    LyCheckboxModule.ctorParameters = function () { return []; };
    return LyCheckboxModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.LyCheckboxModule = LyCheckboxModule;
exports.LyCheckboxService = LyCheckboxService;
exports.LY_CHECKBOX_CONTROL_VALUE_ACCESSOR = LY_CHECKBOX_CONTROL_VALUE_ACCESSOR;
exports.LyCheckbox = LyCheckbox;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__checkbox.umd.js.map
