import { Injectable, ComponentFactoryResolver } from '@angular/core';
import { LyOverlayContainer } from './overlay-container.component';
export class DomService {
    constructor(componentFactoryResolver, overlayContainer) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.overlayContainer = overlayContainer;
    }
    attach(_hostViewContainerRef, component, template) {
        const viewRef = _hostViewContainerRef.createEmbeddedView(template);
        viewRef.detectChanges();
        this._viewContainerRef = _hostViewContainerRef;
        viewRef.rootNodes.forEach(rootNode => this.addChild(rootNode));
    }
    addChild(child) {
        this.overlayContainer.containerElement.appendChild(child);
    }
    getDomElementFromComponentRef(componentRef) {
        return componentRef.hostView
            .rootNodes[0];
    }
    destroyRef(componentRef, delay) {
        setTimeout(() => {
            if (this._viewContainerRef) {
                this._viewContainerRef.detach();
                this._viewContainerRef.clear();
            }
        }, delay);
    }
}
DomService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
DomService.ctorParameters = () => [
    { type: ComponentFactoryResolver, },
    { type: LyOverlayContainer, },
];
//# sourceMappingURL=dom.service.js.map