import { Directive, ElementRef, Input, Renderer2 } from '@angular/core';
import { LyTheme } from '../../theme.service';
export class LyBg {
    constructor(theme, renderer, elementRef) {
        this.theme = theme;
        this.renderer = renderer;
        this.elementRef = elementRef;
        /** Default bg */
        this._bg = 'primary';
        this.prefix = 'bg';
    }
    set bg(color) {
        this._bg = color;
        const key = `${this.prefix}${color || this._bg}`;
        const newStyle = this.theme.createStyle(`ly-${key}`, this.css.bind(this), color);
        this.theme.updateClass(this.elementRef, this.renderer, newStyle.id, this._lastClass);
        this._lastClass = newStyle.id;
    }
    get bg() {
        return this._bg;
    }
    css(bg) {
        return `background:${this.theme.colorOf(bg)};`;
    }
}
LyBg.decorators = [
    { type: Directive, args: [{
                selector: '[bg]'
            },] },
];
/** @nocollapse */
LyBg.ctorParameters = () => [
    { type: LyTheme, },
    { type: Renderer2, },
    { type: ElementRef, },
];
LyBg.propDecorators = {
    "bg": [{ type: Input, args: ['bg',] },],
};
//# sourceMappingURL=bg.directive.js.map