import { Directive, ElementRef, Input, Renderer2 } from '@angular/core';
import { LyTheme } from '../../theme.service';
export class LyColor {
    constructor(theme, renderer, elementRef) {
        this.theme = theme;
        this.renderer = renderer;
        this.elementRef = elementRef;
        /** Default color */
        this._color = 'primary';
        this.prefix = 'color';
    }
    set color(color) {
        this._color = color;
        const key = `${this.prefix}${color || this._color}`;
        const newStyle = this.theme.createStyle(`ly-${key}`, this.css.bind(this), color);
        this.theme.updateClass(this.elementRef, this.renderer, newStyle.id, this._lastClass);
        this._lastClass = newStyle.id;
    }
    get color() {
        return this._color;
    }
    css(color) {
        return `color:${this.theme.colorOf(color)};`;
    }
}
LyColor.decorators = [
    { type: Directive, args: [{
                selector: '[color]'
            },] },
];
/** @nocollapse */
LyColor.ctorParameters = () => [
    { type: LyTheme, },
    { type: Renderer2, },
    { type: ElementRef, },
];
LyColor.propDecorators = {
    "color": [{ type: Input, args: ['color',] },],
};
//# sourceMappingURL=color.directive.js.map