(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('alyle-ui/core'), require('@angular/animations'), require('rxjs/BehaviorSubject'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'alyle-ui/core', '@angular/animations', 'rxjs/BehaviorSubject', '@angular/common'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.drawer = {}),global.ng.core,global.ly.core,global.ng.animations,global.Rx,global.ng.common));
}(this, (function (exports,core,core$1,animations,BehaviorSubject,common) { 'use strict';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var LyDrawerContent = /** @class */ (function () {
    function LyDrawerContent(elementRef, renderer) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.margin = '0 0 0 0';
        this._lyAnimation = true;
        this._el = elementRef.nativeElement;
    }
    LyDrawerContent.prototype.setContentStyle = function (margin) {
        var array = this.margin.split(' ');
        if (margin.left) {
            array[3] = margin.left + "px";
        }
        if (margin.right) {
            array[1] = margin.right + "px";
        }
        if (margin.top) {
            array[0] = margin.top + "px";
        }
        if (margin.bottom) {
            array[2] = margin.bottom + "px";
        }
        this.margin = array.join(' ');
        // const keys = Object.keys(margin);
        // for (let i = 0; i < keys.length; i++) {
        //   const keyName = keys[i];
        //   this.renderer.setStyle(this._drawerContent.elementRef.nativeElement, `margin-${keyName}`, `${margin[keyName]}px`);
        // }
    };
    LyDrawerContent.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-drawer-content'
                },] },
    ];
    /** @nocollapse */
    LyDrawerContent.ctorParameters = function () { return [
        { type: core.ElementRef, },
        { type: core.Renderer2, },
    ]; };
    LyDrawerContent.propDecorators = {
        "margin": [{ type: core.HostBinding, args: ['style.margin',] },],
        "_lyAnimation": [{ type: core.HostBinding, args: ['class.ly--animation',] },],
    };
    return LyDrawerContent;
}());
var LyDrawerContainer = /** @class */ (function () {
    function LyDrawerContainer(renderer, elementRef, animationBuilder) {
        this.renderer = renderer;
        this.elementRef = elementRef;
        this.animationBuilder = animationBuilder;
        this.isDrawerBg = new BehaviorSubject.BehaviorSubject(false);
    }
    LyDrawerContainer.prototype._closeAllSideAndPush = function () {
        var _this = this;
        this._drawers.forEach(function (drawer) {
            if (drawer.mode === 'over' || drawer.mode === 'push') {
                drawer.close();
                _this.isDrawerBg.next('inactive');
            }
        });
    };
    /** Close all open drawers */
    /** Close all open drawers */
    LyDrawerContainer.prototype.closeAll = /** Close all open drawers */
    function () {
        this._drawers.forEach(function (drawer) {
            if (drawer.open) {
                drawer.close();
            }
        });
        this.isDrawerBg.next('inactive');
    };
    LyDrawerContainer.decorators = [
        { type: core.Component, args: [{
                    selector: 'ly-drawer-container',
                    styles: [":host { display: block; overflow: hidden; -webkit-overflow-scrolling: touch; box-sizing: border-box; position: relative; } :host ::ng-deep > ly-drawer-content { height: 100%; overflow: auto; display: block; } :host ::ng-deep > ly-drawer-content.ly--animation { transition: 375ms cubic-bezier(0.45, 0, 0.25, 1); } .ly-drawer-bg { position: absolute; top: 0; left: 0; right: 0; bottom: 0; opacity: .6; z-index: 10; user-select: none; } .ly-drawer-bg-opened { display: block; } .ly-drawer-bg-closed { display: none; } "],
                    animations: [
                        animations.trigger('in', [
                            animations.state('inactive, 0', animations.style({ opacity: '0', 'display': 'none' })),
                            animations.state('active, 1', animations.style({ opacity: '.6' })),
                            animations.transition('* => active', animations.animate('375ms ease-in')),
                            animations.transition('* => inactive', animations.animate('375ms ease-out')),
                        ])
                    ],
                    template: "\n  <ng-content select=\"ly-drawer\"></ng-content>\n  <ng-content select=\"ly-drawer-content\"></ng-content>\n  <div\n  #bg\n  [class.ly-drawer-bg-opened]=\"isDrawerBg | async\"\n  [class.ly-drawer-bg-closed]=\"!(isDrawerBg | async)\"\n  [@in]=\"isDrawerBg | async\" class=\"ly-drawer-bg\"\n  bg=\"colorText\"\n  (click)=\"_closeAllSideAndPush()\"\n  ></div>\n  ",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    preserveWhitespaces: false,
                    exportAs: 'lyDrawerContainer'
                },] },
    ];
    /** @nocollapse */
    LyDrawerContainer.ctorParameters = function () { return [
        { type: core.Renderer2, },
        { type: core.ElementRef, },
        { type: animations.AnimationBuilder, },
    ]; };
    LyDrawerContainer.propDecorators = {
        "_drawers": [{ type: core.ContentChildren, args: [core.forwardRef(function () { return LyDrawer; }),] },],
        "_drawerContent": [{ type: core.ContentChild, args: [core.forwardRef(function () { return LyDrawerContent; }),] },],
    };
    return LyDrawerContainer;
}());
var LyDrawer = /** @class */ (function () {
    function LyDrawer(drawerContainer, elementRef) {
        this.drawerContainer = drawerContainer;
        this.elementRef = elementRef;
        this._opened = false;
        this.config = {
            width: 200,
            height: 200
        };
        this.mode = 'side';
        this.position = 'left';
        this.isOpenDrawer = false;
        this.isDrawerHidden = true;
    }
    Object.defineProperty(LyDrawer.prototype, "opened", {
        get: function () { return this._opened; },
        set: function (val) {
            this.isOpenDrawer = val;
            this._opened = val;
            val ? this.open(true) : this.close(false);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyDrawer.prototype, "_elementRect", {
        get: function () {
            return this.elementRef.nativeElement.getBoundingClientRect();
        },
        enumerable: true,
        configurable: true
    });
    LyDrawer.prototype.updateDrawerMargin = function () {
        if (this.mode === 'side' || this.mode === 'push') {
            var width = this.config.width;
            var height = this.config.height;
            if (width !== 0 && this.position === 'left' || this.position === 'right') {
                var margin = {};
                margin[this.position] = width;
                this.drawerContainer._drawerContent.setContentStyle(margin);
            }
            if (height !== 0 && this.position === 'top' || this.position === 'bottom') {
                var margin = {};
                margin[this.position] = height;
                this.drawerContainer._drawerContent.setContentStyle(margin);
            }
        }
    };
    LyDrawer.prototype.toBoolean = function (drawerState) {
        if (drawerState === true || drawerState === 'open') {
            return true;
        }
        else {
            return false;
        }
    };
    LyDrawer.prototype.toggle = function () {
        this.toBoolean(this.isOpenDrawer) ? this.close() : this.open();
    };
    LyDrawer.prototype.open = function (is) {
        this.toogleDrawer(is);
        this.isDrawerHidden = false;
        this.isOpenDrawer = is || 'open';
        this.drawerContainer._drawerContent._lyAnimation = this.isOpenDrawer === 'open';
        this.updateDrawerMargin();
        this.setBgState(is || 'active');
        return this.isOpenDrawer;
    };
    LyDrawer.prototype.close = function (is) {
        this.toogleDrawer(is);
        this.resetMargin();
        this.isOpenDrawer = is === false || is === true ? false : 'close';
        this.drawerContainer._drawerContent._lyAnimation = this.isOpenDrawer === 'close';
        this.setBgState(is === false ? false : 'inactive');
        return this.isOpenDrawer;
    };
    LyDrawer.prototype.toogleDrawer = function (status) {
        this.isShowDrawer = this.toBoolean(status);
    };
    LyDrawer.prototype.setBgState = function (bgState) {
        if (this.mode === 'over' || this.mode === 'push') {
            this.drawerContainer.isDrawerBg.next(bgState);
        }
    };
    LyDrawer.prototype.resetMargin = function () {
        var margin = {};
        margin[this.position] = '0';
        this.drawerContainer._drawerContent.setContentStyle(margin);
    };
    LyDrawer.prototype.ngOnChanges = function (changes) {
        var _this = this;
        Object.keys(changes).forEach(function (key) {
            /**for `position` changes */
            if (key === 'position' && changes[key].currentValue === 'rtl') {
                _this.position = 'right';
            }
            /** Update mode */
            if (changes['mode'] && !changes[key].firstChange) {
                _this.toBoolean(_this.isOpenDrawer) ? _this.open(true) : _this.close(false);
            }
        });
    };
    LyDrawer.decorators = [
        { type: core.Component, args: [{
                    selector: 'ly-nav, ly-drawer',
                    styles: [":host { display: block; position: fixed; box-sizing: border-box; overflow: auto; z-index: 11; } :host[position=top] { top: 0; transform: translate3d(0, -100%, 0); } :host[position=left] { left: 0; transform: translate3d(-100%, 0, 0); } :host[position=right], :host[position=rtl] { right: 0; transform: translate3d(100%, 0, 0); } :host[position=bottom] { bottom: 0; transform: translate3d(0, 100%, 0); } :host.ly-show-drawer { transform: translate3d(0, 0, 0); } :host.ly-drawer-hidden { visibility: hidden; } "],
                    animations: [
                        animations.trigger('visibilityChanged', [
                            animations.state('true, open', animations.style({ transform: 'translate3d(0, 0, 0)' })),
                            animations.transition('* => open, * => close', [
                                animations.animate('375ms cubic-bezier(.45, 0, .25, 1)')
                            ])
                        ])
                    ],
                    template: "<ng-content></ng-content>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    preserveWhitespaces: false,
                    exportAs: 'lyDrawer'
                },] },
    ];
    /** @nocollapse */
    LyDrawer.ctorParameters = function () { return [
        { type: LyDrawerContainer, decorators: [{ type: core.Optional },] },
        { type: core.ElementRef, },
    ]; };
    LyDrawer.propDecorators = {
        "config": [{ type: core.Input },],
        "mode": [{ type: core.HostBinding, args: ['attr.mode',] }, { type: core.Input },],
        "position": [{ type: core.HostBinding, args: ['attr.position',] }, { type: core.Input },],
        "isShowDrawer": [{ type: core.HostBinding, args: ['class.ly-show-drawer',] },],
        "isOpenDrawer": [{ type: core.HostBinding, args: ['@visibilityChanged',] },],
        "isDrawerHidden": [{ type: core.HostBinding, args: ['class.ly-drawer-hidden',] },],
        "opened": [{ type: core.Input },],
    };
    __decorate([
        core$1.IsBoolean(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], LyDrawer.prototype, "opened", null);
    return LyDrawer;
}());

var LyDrawerModule = /** @class */ (function () {
    function LyDrawerModule() {
    }
    LyDrawerModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                        core$1.ThemeModule
                    ],
                    exports: [LyDrawer, LyDrawerContainer, LyDrawerContent],
                    declarations: [LyDrawer, LyDrawerContainer, LyDrawerContent],
                },] },
    ];
    /** @nocollapse */
    LyDrawerModule.ctorParameters = function () { return []; };
    return LyDrawerModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.LyDrawerContent = LyDrawerContent;
exports.LyDrawerContainer = LyDrawerContainer;
exports.LyDrawer = LyDrawer;
exports.LyDrawerModule = LyDrawerModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__drawer.umd.js.map
