(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('alyle-ui/ripple-minimal'), require('alyle-ui/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'alyle-ui/ripple-minimal', 'alyle-ui/core', '@angular/common'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.iconButton = {}),global.ng.core,global.ly.rippleMinimal,global.ly.core,global.ng.common));
}(this, (function (exports,core,rippleMinimal,core$1,common) { 'use strict';

var LyIconButton = /** @class */ (function () {
    function LyIconButton(elementRef) {
        this.elementRef = elementRef;
        this._size = '24px';
        if (core$1.Platform.isBrowser) {
            this.nativeElement = this.elementRef.nativeElement;
            if (this.nativeElement.nodeName.toLowerCase() === 'ly-icon-button') {
                console.log("ly-icon-button:", this.nativeElement, " is deprecated instead use button[ly-icon-button]");
            }
        }
    }
    Object.defineProperty(LyIconButton.prototype, "size", {
        get: function () {
            return this._size;
        },
        set: function (val) {
            if (typeof val === 'number') {
                this._size = val + "px";
            }
            else {
                this._size = val;
            }
            this._updateSize();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyIconButton.prototype, "iconStyle", {
        get: function () {
            return this._iconStyle;
        },
        set: function (style) {
            this.assignStyle(style);
        },
        enumerable: true,
        configurable: true
    });
    LyIconButton.prototype.assignStyle = function (newStyle) {
        this._iconStyle = Object.assign(this.iconStyle || {}, newStyle);
    };
    LyIconButton.prototype.ngOnChanges = function (changes) {
        // #
    };
    LyIconButton.prototype.ngOnInit = function () {
        if (!this.iconStyle) {
            this._updateSize();
        }
    };
    LyIconButton.prototype._updateSize = function () {
        var wh = "calc(" + this._size + " * 2)";
        var style = {
            'width': wh,
            'height': wh,
            'font-size': this._size
        };
        this.assignStyle(style);
    };
    LyIconButton.prototype.ngAfterViewInit = function () {
        if (core$1.Platform.isBrowser) {
            this.ripple.lyRippleDisabled = true;
            this.ripple.rippleContainer.setTriggerElement(this.nativeElement);
            this.ripple.rippleContainer.setContainerElement(this.nativeElement);
            this.ripple.lyRippleDisabled = false;
        }
    };
    LyIconButton.prototype.ngOnDestroy = function () { };
    LyIconButton.decorators = [
        { type: core.Component, args: [{
                    selector: 'button[ly-icon-button], a[ly-icon-button], ly-icon-button',
                    styles: [":host { user-select: none; -webkit-tap-highlight-color: transparent; display: inline-flex; background: transparent; border: 0; padding: 0; cursor: pointer; outline: none; box-sizing: border-box; color: currentColor; } .ly-icon-button-content { display: inline-flex; justify-content: center; align-items: center; } .ly-icon-button-content ::ng-deep [ly-svg], .ly-icon-button-content ::ng-deep ly-svg { width: 100%; height: 100%; } "],
                    template: "\n  <div class=\"ly-icon-button-content\" [ngStyle]=\"iconStyle\"\n  lyRipple\n  lyRippleSensitive\n  lyRippleCentered\n  lyRippleRadius=\"containerSize\"\n  >\n    <ng-content></ng-content>\n  </div>\n  ",
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    exportAs: 'lyIconButton'
                },] },
    ];
    /** @nocollapse */
    LyIconButton.ctorParameters = function () { return [
        { type: core.ElementRef, },
    ]; };
    LyIconButton.propDecorators = {
        "ripple": [{ type: core.ViewChild, args: [rippleMinimal.LyRipple,] },],
        "size": [{ type: core.Input, args: ['size',] },],
        "iconStyle": [{ type: core.Input },],
    };
    return LyIconButton;
}());

var LyIconButtonModule = /** @class */ (function () {
    function LyIconButtonModule() {
    }
    LyIconButtonModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, rippleMinimal.LyRippleModule],
                    exports: [LyIconButton],
                    declarations: [LyIconButton],
                },] },
    ];
    /** @nocollapse */
    LyIconButtonModule.ctorParameters = function () { return []; };
    return LyIconButtonModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.LyIconButtonModule = LyIconButtonModule;
exports.LyIconButton = LyIconButton;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__icon-button.umd.js.map
