(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs/Subject'), require('@angular/common'), require('alyle-ui/core')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'rxjs/Subject', '@angular/common', 'alyle-ui/core'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.input = {}),global.ng.core,global.ng.forms,global.Rx,global.ng.common,global.ly.core));
}(this, (function (exports,core,forms,Subject,common,core$1) { 'use strict';

var LyInputContents = /** @class */ (function () {
    function LyInputContents() {
    }
    LyInputContents.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-before-input, ly-after-input'
                },] },
    ];
    /** @nocollapse */
    LyInputContents.ctorParameters = function () { return []; };
    return LyInputContents;
}());

var LyFieldDirective = /** @class */ (function () {
    function LyFieldDirective(elementRef, _ngControl, _parentForm, _parentFormGroup, cd) {
        this.elementRef = elementRef;
        this._ngControl = _ngControl;
        this._parentForm = _parentForm;
        this._parentFormGroup = _parentFormGroup;
        this.cd = cd;
        this.focusState = new Subject.Subject();
        this._disabled = false;
        this._required = false;
    }
    LyFieldDirective.prototype.focus = function (isFocused) {
        this.focusState.next(isFocused);
    };
    LyFieldDirective.prototype._blur = function (isFocused) {
        this.focusState.next(isFocused);
    };
    LyFieldDirective.prototype._noop = function () { };
    Object.defineProperty(LyFieldDirective.prototype, "disabled", {
        get: function () { return this._ngControl ? this._ngControl.disabled : this._disabled; },
        set: function (value) { this._disabled = !!(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyFieldDirective.prototype, "required", {
        get: function () { return this._ngControl ? this._ngControl.invalid : this._required; },
        set: function (value) { this._required = !!(value); },
        enumerable: true,
        configurable: true
    });
    LyFieldDirective.prototype.markForCheck = function () {
        this.cd.markForCheck();
    };
    LyFieldDirective.prototype._parent = function () {
        return this._parentFormGroup || this._parentForm;
    };
    LyFieldDirective.prototype._updateErrorState = function () {
        // const oldState = this.errorState;
        var parent = this._parentFormGroup || this._parentForm;
        // const matcher = this.errorStateMatcher || this._defaultErrorStateMatcher;
        var control = this._ngControl ? this._ngControl.control : null;
        // const newState = matcher.isErrorState(control, parent);
        // if (newState !== oldState) {
        //   this.errorState = newState;
        //   this.stateChanges.next();
        // }
    };
    LyFieldDirective.prototype.ngOnChanges = function (changes) {
        // if (!changes['placeholder'].firstChange) {
        //   console.log(JSON.stringify(changes['placeholder']))
        // }
    };
    LyFieldDirective.prototype.ngOnDestroy = function () {
        this.focusState.complete();
    };
    LyFieldDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-input input, ly-textarea textarea'
                },] },
    ];
    /** @nocollapse */
    LyFieldDirective.ctorParameters = function () { return [
        { type: core.ElementRef, },
        { type: forms.NgControl, decorators: [{ type: core.Optional }, { type: core.Self },] },
        { type: forms.NgForm, decorators: [{ type: core.Optional },] },
        { type: forms.FormGroupDirective, decorators: [{ type: core.Optional },] },
        { type: core.ChangeDetectorRef, },
    ]; };
    LyFieldDirective.propDecorators = {
        "type": [{ type: core.Input },],
        "focus": [{ type: core.HostListener, args: ['focus', ['true'],] },],
        "_blur": [{ type: core.HostListener, args: ['blur', ['false'],] },],
        "_noop": [{ type: core.HostListener, args: ['input',] },],
        "disabled": [{ type: core.Input },],
        "required": [{ type: core.Input },],
    };
    return LyFieldDirective;
}());

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var LyInputCommon = /** @class */ (function () {
    function LyInputCommon() {
    }
    LyInputCommon.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-default, ly-before, ly-after, ly-input ly-error, ly-input ly-hint'
                },] },
    ];
    /** @nocollapse */
    LyInputCommon.ctorParameters = function () { return []; };
    return LyInputCommon;
}());
var LyPlaceholder = /** @class */ (function () {
    function LyPlaceholder() {
    }
    LyPlaceholder.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-placeholder'
                },] },
    ];
    /** @nocollapse */
    LyPlaceholder.ctorParameters = function () { return []; };
    return LyPlaceholder;
}());
var LyDefault = /** @class */ (function () {
    function LyDefault() {
    }
    LyDefault.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-default'
                },] },
    ];
    /** @nocollapse */
    LyDefault.ctorParameters = function () { return []; };
    return LyDefault;
}());
var LyLabel = /** @class */ (function () {
    function LyLabel() {
    }
    LyLabel.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-label'
                },] },
    ];
    /** @nocollapse */
    LyLabel.ctorParameters = function () { return []; };
    return LyLabel;
}());
var LyInput = /** @class */ (function () {
    function LyInput(theme, styleTheme, _changeDetectorRef) {
        // this.paletteSubscription = this.theme.palette.subscribe((palette) => {
        //   this._inputColor = this.theme.colorOf(this._color);
        // });
        this.theme = theme;
        this.styleTheme = styleTheme;
        this._changeDetectorRef = _changeDetectorRef;
        this._color = 'primary';
        this._inputColor = 'primary';
        this.changed = new Array();
        this.touched = new Array();
        this.type = 'text';
    }
    Object.defineProperty(LyInput.prototype, "isFloatingLabel", {
        get: function () {
            return this.currentValueState || this.labelAbove || this.isDefault || this.focusState;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "placeholderState", {
        get: function () {
            return !this.currentValueState && this.focusState || !this.currentValueState && !this.focusState && this.isFloatingLabel;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "inputColor", {
        get: function () {
            return this._inputColor;
        },
        set: /**
           * inputColor
           */
        function (val) {
            // this._color = val;
            if (val) {
                this._inputColor = val;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "defaultOff", {
        get: function () {
            return this.currentValue === this.default && !this.focusState || !this.currentValueState && !this.focusState;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "disabled", {
        get: function () { return this._field.disabled; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "required", {
        get: function () { return this._field.required; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "currentValueState", {
        get: function () {
            return ("" + this.currentValue).length !== 0 && this.currentValue != null;
        },
        enumerable: true,
        configurable: true
    });
    LyInput.prototype._valueBoolean = function (val) {
        return !(val === null || val === undefined || val === false || val === '');
    };
    LyInput.prototype._isErrorState = function () {
        if (this._field) {
            return this._field._ngControl.invalid && this._field._ngControl.touched || this._errorState;
        }
    };
    LyInput.prototype.updateError = function () {
        this._errorState = this._field._ngControl.invalid;
    };
    LyInput.prototype.value = function () {
        return this.currentValue;
    };
    LyInput.prototype.toBoolean = function (val) {
        return core$1.toBoolean(val);
    };
    Object.defineProperty(LyInput.prototype, "isPlaceholder", {
        get: function () {
            return core$1.toBoolean(this.placeholder) || !!this.lyPlaceholder;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "isDefault", {
        get: function () {
            return core$1.toBoolean(this.default) || !!this.lyDefault;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyInput.prototype, "isLabel", {
        get: function () {
            return core$1.toBoolean(this.label) || !!this.lyLabel;
        },
        enumerable: true,
        configurable: true
    });
    LyInput.prototype.ngOnInit = function () {
        var _this = this;
        // this._inputColor = this.theme.colorOf(this._color);
        this.focusStateSuscription = this._field.focusState.subscribe(function (fState) {
            _this.focusState = fState;
        });
        if (this._field._parent()) {
            this._field._parent().ngSubmit.subscribe(function (submit) {
                _this.updateError();
            });
        }
    };
    LyInput.prototype.ngAfterViewInit = function () {
    };
    LyInput.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (this._field) {
            this.currentValue = this._field._ngControl.value;
            if (this._field._ngControl && this._field._ngControl.valueChanges) {
                this._field._ngControl.valueChanges.subscribe(function (val) {
                    _this.currentValue = val;
                    _this._errorState = false;
                    _this._changeDetectorRef.markForCheck();
                    /**
                               * reset error of submit to false
                               */
                });
            }
            this._field.focusState.subscribe(function (isFocused) {
                if (_this.isDefault) {
                    if (!_this.currentValueState) {
                        _this.currentValue = _this.default;
                        _this._field._ngControl.valueAccessor.writeValue(_this.default);
                        _this._field._ngControl.viewToModelUpdate(_this.default);
                    }
                }
                _this._field.markForCheck();
                _this._changeDetectorRef.markForCheck();
            });
        }
        else {
            console.warn('LyInput: Require input native');
        }
    };
    LyInput.prototype._shouldForward = function (prop) {
        var control = this._field ? this._field._ngControl : null;
        return control && control[prop];
    };
    LyInput.prototype.ngOnChanges = function (changes) {
        if (changes.default) {
            if (this.isDefault && !this.currentValueState) {
                this.currentValue = this.default;
                this._field._ngControl.viewToModelUpdate(this.default);
            }
        }
    };
    LyInput.prototype.ngOnDestroy = function () {
        this.focusStateSuscription.unsubscribe();
    };
    LyInput.decorators = [
        { type: core.Component, args: [{
                    selector: 'ly-text-field, ly-input, ly-textarea',
                    styles: [":host { display: inline-block; position: relative; align-items: center; } :host /deep/ ly-before, :host /deep/ ly-after { display: inline-block; vertical-align: inherit; } :host /deep/ input, :host /deep/ textarea { border: none; outline: none; font-family: inherit; color: inherit; background: transparent; font-size: inherit; width: 100%; font-weight: 400; padding: 0; display: inline-flex; } :host.ly-hidden-input /deep/ .ly-input-container input, :host.ly-hidden-input /deep/ .ly-input-container textarea, :host.ly-default-off .ly-input-default { opacity: 0; } /** * Focus Input **/ :host.ly-focus-active .ly-input-underline:after { width: 100%; } :host.ly-focus-active .ly-input-top-label, :host.ly-focus-active /deep/ ly-top-label { font-size: 75%; top: 0; transform: translate(0, 0); } :host.ly-focus-active .ly-input-default { opacity: 0; } :host.ly-value-on .ly-input-placeholder { opacity: 0; } .ly-input-underline { position: absolute; bottom: 0.875em; height: 1px; right: 0; left: 0; } .ly-input-underline:after { content: ''; position: absolute; width: 0%; height: 2px; background: currentColor; left: 0; right: 0; margin: 0 auto; bottom: 0; transition: all 450ms cubic-bezier(0.23, 1, 0.32, 1) 0ms; } .ly-input-underline.ly-disabled { background: transparent; background-image: linear-gradient(to right, #b4b4b4 0%, #b4b4b4 33%, transparent 0%); background-size: 4px 1px; background-repeat: repeat-x; border-top: 0; background-position: 0; } .ly-input-underline.ly-disabled:after { width: 0%; } :host.ly-label-above .ly-input-float-label { font-size: 75%; top: 0; } /** * ly-label(placeholder) */ .ly-input-placeholder, .ly-input-default, .ly-input-float-label { pointer-events: none; position: absolute; bottom: 1.125em; top: 1.125em; margin: auto; font-size: 100%; transition: all 375ms cubic-bezier(0.23, 1, 0.32, 1); color: inherit; width: 100%; } .ly-input-content { width: 100%; position: relative; display: flex; } .ly-input-container { padding: 1.125em 0; position: relative; opacity: 1; display: inline-block; vertical-align: inherit; width: 100%; } .ly-input-container ::ng-deep input { text-align: inherit; } .bottom-field, .ly-error-container { position: absolute; bottom: 0; left: 0; width: 100%; pointer-events: none; font-size: 75%; transform: translate3d(0, calc(100% - 1.1em), 0); display: flex; } .bottom-field .bottom-field-space, .ly-error-container .bottom-field-space { flex: 1; } .ly-required { position: absolute; top: 1.125em; right: 0; pointer-events: none; transform: translate3d(0, 0, 0); opacity: 0.45; } :host.ly-input-invalid .ly-input-underline, :host.ly-input-invalid .ly-input-placeholder, :host.ly-input-invalid /deep/ ly-error, :host.ly-input-invalid .ly-input-float-label { color: #F44336 !important; } :host.ly-input-invalid .ly-input-underline:after { width: 100%; } .ly-input-content { color: currentColor; } "],
                    template: "<ng-content select=\"ly-before\"></ng-content> <div class=\"ly-input-underline\" [color]=\"inputColor\" bg=\"input:underline\"></div> <div class=\"ly-input-container\"> <ng-content select=\"input, textarea\"></ng-content> <!-- ly-placeholder --> <ng-container *ngIf=\"placeholder; then isPlaceholderTemplate; else placeholderContainer\"></ng-container> <ng-template #isPlaceholderTemplate> <div *ngIf=\"toBoolean(placeholder) !== undefined && placeholderState\" color=\"input:label\" class=\"ly-input-placeholder\">{{ placeholder }}</div> </ng-template> <ng-template #placeholderContainer> <div *ngIf=\"lyPlaceholder !== undefined && placeholderState\" color=\"input:label\" class=\"ly-input-placeholder\"> <ng-content select=\"ly-placeholder\"></ng-content> </div> </ng-template> <!-- ly-default --> <ng-container *ngIf=\"toBoolean(default); then isDefaultTemplate\"></ng-container> <ng-template #isDefaultTemplate> <div *ngIf=\"!(lyDefault !== undefined) && defaultOff\" color=\"input:label\" class=\"ly-input-default\">Default: {{ default }}</div> <div *ngIf=\"lyDefault !== undefined && defaultOff\" color=\"input:label\" class=\"ly-input-default\"> <ng-content select=\"ly-default\"></ng-content>{{ default }} </div> </ng-template> <!-- ly-label --> <ng-container *ngIf=\"toBoolean(label); then _isLabelTemplate; else labelContainer\"></ng-container> <ng-template #_isLabelTemplate> <div *ngIf=\"label !== undefined\" color=\"input:label\" class=\"ly-input-float-label\">{{ label }}</div> </ng-template> <ng-template #labelContainer> <div *ngIf=\"lyLabel\" color=\"input:label\" class=\"ly-input-float-label\"> <ng-content select=\"ly-label\"></ng-content> </div> </ng-template> </div> <div class=\"ly-icon-required\" *ngIf=\"required\"></div> <div class=\"bottom-field\" *ngIf=\"!_isErrorState()\"> <ng-content select=\"ly-hint[align=start], ly-hint:not(ly-hint[align])\"></ng-content> <span class=\"bottom-field-space\"></span> <ng-content select=\"ly-hint[align=end]\"></ng-content> </div> <div class=\"bottom-field\" *ngIf=\"_isErrorState()\"> <ng-content select=\"ly-error\"></ng-content> </div> <ng-content select=\"ly-after\"></ng-content> ",
                    // tslint:disable-next-line:use-host-property-decorator
                    host: {
                        '[class.ly-input-invalid]': '_isErrorState()',
                        '[class.ng-untouched]': '_shouldForward("untouched")',
                        '[class.ng-touched]': '_shouldForward("touched")',
                        '[class.ng-pristine]': '_shouldForward("pristine")',
                        '[class.ng-dirty]': '_shouldForward("dirty")',
                        '[class.ng-valid]': '_shouldForward("valid")',
                        '[class.ng-invalid]': '_shouldForward("invalid")',
                        '[class.ng-pending]': '_shouldForward("pending")',
                    },
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    preserveWhitespaces: false
                },] },
    ];
    /** @nocollapse */
    LyInput.ctorParameters = function () { return [
        { type: core$1.LyTheme, },
        { type: core$1.LyStyleTheme, },
        { type: core.ChangeDetectorRef, },
    ]; };
    LyInput.propDecorators = {
        "_field": [{ type: core.ContentChild, args: [LyFieldDirective,] },],
        "lyPlaceholder": [{ type: core.ContentChild, args: [LyPlaceholder,] },],
        "lyDefault": [{ type: core.ContentChild, args: [LyDefault,] },],
        "lyLabel": [{ type: core.ContentChild, args: [LyLabel,] },],
        "type": [{ type: core.Input },],
        "label": [{ type: core.Input },],
        "placeholder": [{ type: core.Input },],
        "labelAbove": [{ type: core.Input },],
        "default": [{ type: core.Input },],
        "isFloatingLabel": [{ type: core.HostBinding, args: ['class.ly-label-above',] },],
        "inputColor": [{ type: core.Input, args: ['inputColor',] },],
        "focusState": [{ type: core.HostBinding, args: ['class.ly-focus-active',] },],
        "defaultOff": [{ type: core.HostBinding, args: ['class.ly-hidden-input',] },],
        "disabled": [{ type: core.Input },],
        "required": [{ type: core.Input },],
        "currentValueState": [{ type: core.HostBinding, args: ['class.ly-value-on',] },],
    };
    __decorate([
        core$1.IsBoolean(),
        __metadata("design:type", Boolean)
    ], LyInput.prototype, "labelAbove", void 0);
    return LyInput;
}());
var LyInputModule = /** @class */ (function () {
    function LyInputModule() {
    }
    LyInputModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule, core$1.ThemeModule],
                    exports: [LyInput, LyInputContents, LyFieldDirective, LyInputCommon, LyDefault, LyLabel, LyPlaceholder],
                    declarations: [LyInput, LyInputContents, LyFieldDirective, LyInputCommon, LyDefault, LyLabel, LyPlaceholder],
                },] },
    ];
    /** @nocollapse */
    LyInputModule.ctorParameters = function () { return []; };
    return LyInputModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.LyInputCommon = LyInputCommon;
exports.LyPlaceholder = LyPlaceholder;
exports.LyDefault = LyDefault;
exports.LyLabel = LyLabel;
exports.LyInput = LyInput;
exports.LyInputModule = LyInputModule;
exports.LyInputContents = LyInputContents;
exports.LyFieldDirective = LyFieldDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__input.umd.js.map
