(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs/Observable'), require('rxjs/Subject'), require('rxjs/observable/fromEvent')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'rxjs/Observable', 'rxjs/Subject', 'rxjs/observable/fromEvent'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.ls = {}),global.ng.core,global.ng.common,global.Rx,global.Rx,global.Rx.Observable));
}(this, (function (exports,core,common,Observable,Subject,fromEvent) { 'use strict';

var MinimalStorage = /** @class */ (function () {
    function MinimalStorage(key$, val) {
        localStorage.setItem(key$, JSON.stringify(val));
    }
    return MinimalStorage;
}());
var MinimalLS = /** @class */ (function () {
    function MinimalLS(platformId) {
        var _this = this;
        this.platformId = platformId;
        this.itemsSubject = new Map();
        this._prefix = '*ls*';
        this.storage = new Subject.Subject();
        if (common.isPlatformBrowser(this.platformId)) {
            this.storageEvent = fromEvent.fromEvent(window, 'storage');
            this.storageEvent.subscribe(function (e) {
                _this.storage.next({
                    key: e.key,
                    value: e.newValue
                });
            });
            this.storageObservable = this.storage.asObservable();
        }
    }
    /**
     * get boolean
     */
    /**
       * get boolean
       */
    MinimalLS.prototype.hasItem = /**
       * get boolean
       */
    function (key$) {
        var key = this._addPrefix(key$);
        if (common.isPlatformBrowser(this.platformId)) {
            return !!localStorage.getItem(key);
        }
        if (common.isPlatformServer(this.platformId)) {
            return false;
        }
    };
    /**
     * Set new item or replace item
     */
    /**
       * Set new item or replace item
       */
    MinimalLS.prototype.setItem = /**
       * Set new item or replace item
       */
    function (key$, val, _storage) {
        if (_storage === void 0) { _storage = true; }
        var key = this._addPrefix(key$);
        if (_storage) {
            if (common.isPlatformBrowser(this.platformId)) {
                // tslint:disable-next-line:no-unused-expression
                new MinimalStorage(key, val);
            }
        }
        this.storage.next({
            key: key,
            value: this.item(key$)
        });
        // this.itemsSubject.set(key, new BehaviorSubject<string>(val));
    };
    /**
     * Get Observable from localStorage
     */
    /**
       * Get Observable from localStorage
       */
    MinimalLS.prototype.getItem = /**
       * Get Observable from localStorage
       */
    function (key$, before) {
        var _this = this;
        var key = this._addPrefix(key$);
        var ob = new Observable.Observable(function (observer) {
            if (_this.hasItem(key$)) {
                observer.next(_this.item(key$));
            }
            _this.storageObservable.subscribe(function (e) {
                if (key === e.key) {
                    observer.next(e.value);
                }
            });
        });
        return ob;
    };
    /**
     * Get value from localstorage
     */
    /**
       * Get value from localstorage
       */
    MinimalLS.prototype.item = /**
       * Get value from localstorage
       */
    function (key$) {
        var key = this._addPrefix(key$);
        try {
            return JSON.parse(window.localStorage[key]);
        }
        catch (e) {
            return null;
        }
    };
    MinimalLS.prototype._addPrefix = function (val) {
        return "{\"" + this._prefix + "\":\"" + val + "\"}";
    };
    MinimalLS.prototype._removePrefix = function (val) {
        try {
            return JSON.parse(val)[this._prefix];
        }
        catch (e) {
            return null;
        }
    };
    MinimalLS.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    MinimalLS.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] },] },
    ]; };
    return MinimalLS;
}());

var MinimalLSModule = /** @class */ (function () {
    function MinimalLSModule() {
    }
    MinimalLSModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [
                        MinimalLS
                    ]
                },] },
    ];
    /** @nocollapse */
    MinimalLSModule.ctorParameters = function () { return []; };
    return MinimalLSModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.MinimalStorage = MinimalStorage;
exports.MinimalLS = MinimalLS;
exports.MinimalLSModule = MinimalLSModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__ls.umd.js.map
