var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, forwardRef, NgModule, Input, Output, ChangeDetectorRef, ContentChildren, QueryList, Optional, HostBinding, EventEmitter, ChangeDetectionStrategy, NgZone, ViewChild, ElementRef } from '@angular/core';
import { LyRippleModule, LyRipple } from 'alyle-ui/ripple-minimal';
import { NG_VALUE_ACCESSOR, FormsModule, } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { LyTheme, LyStyleTheme, ThemeModule, Platform, IsBoolean } from 'alyle-ui/core';
export const LY_RADIO_CONTROL_VALUE_ACCESSOR = {
    provide: NG_VALUE_ACCESSOR,
    useExisting: forwardRef(() => LyRadioGroup),
    multi: true
};
let idx = 0;
export class LyRadioGroup {
    constructor(elementRef, theme, styleTheme, ngZone, cd) {
        this.elementRef = elementRef;
        this.theme = theme;
        this.styleTheme = styleTheme;
        this.ngZone = ngZone;
        this.cd = cd;
        this._value = null;
        this.name = `ly-radio-name-${idx++}`;
        this._color = 'accent';
        this.value = null;
        this.radioColor = 'accent';
        this.changed = new Array();
        this.touched = new Array();
    }
    touch() {
        this.touched.forEach(f => f());
    }
    registerOnChange(fn) {
        this.changed.push(fn);
    }
    registerOnTouched(fn) {
        this.touched.push(fn);
    }
    writeValue(value) {
        this._value = value;
    }
    ngAfterContentInit() {
    }
    updatevalue(value) {
        this._value = value;
        this.changed.forEach(f => f(value));
    }
    markForCheck() {
        this.cd.markForCheck();
    }
    ngAfterViewInit() {
        /**set value null if all checked === false */
        Promise.resolve(null).then(() => {
            const stateChecked = this._radios.find((radio, index) => radio.checked);
            if (!stateChecked) {
                this.updatevalue(null);
                this.markForCheck();
            }
        });
    }
}
LyRadioGroup.decorators = [
    { type: Component, args: [{
                selector: 'ly-radio-group',
                styles: [`
    :host {
      display: inline-flex;
    }
  `],
                template: `<ng-content></ng-content>`,
                providers: [LY_RADIO_CONTROL_VALUE_ACCESSOR],
                changeDetection: ChangeDetectionStrategy.OnPush,
                preserveWhitespaces: false
            },] },
];
/** @nocollapse */
LyRadioGroup.ctorParameters = () => [
    { type: ElementRef, },
    { type: LyTheme, },
    { type: LyStyleTheme, },
    { type: NgZone, },
    { type: ChangeDetectorRef, },
];
LyRadioGroup.propDecorators = {
    "value": [{ type: Input },],
    "radioColor": [{ type: Input, args: ['radioColor',] },],
    "_radios": [{ type: ContentChildren, args: [forwardRef(() => LyRadio),] },],
};
export class LyRadio {
    constructor(radioGroup, theme, changeDetectorRef, ngZone) {
        this.radioGroup = radioGroup;
        this.theme = theme;
        this.changeDetectorRef = changeDetectorRef;
        this.ngZone = ngZone;
        this.id = `ly-radio-id-${idx++}`;
        this.name = '';
        this._value = null;
        this._checked = false;
        this.onCheckedState = new EventEmitter();
    }
    get inputId() {
        return `${this.id}-input`;
    }
    _onInputChange(event) {
        this.radioGroup.updatevalue(this.value);
    }
    ngOnChanges(changes) {
        if (changes['checked']) {
            if (this.checked) {
                Promise.resolve(null).then(() => {
                    this.radioGroup.updatevalue(this.value);
                });
            }
        }
    }
    ngOnInit() {
        if (this.radioGroup) {
            // Copy name from parent radio group
            this.name = this.radioGroup.name;
        }
    }
    ngAfterViewInit() {
        if (Platform.isBrowser) {
            this.ripple.lyRippleDisabled = true;
            this.ripple.rippleContainer.setTriggerElement(this._labelContainer.nativeElement);
            this.ripple.lyRippleDisabled = false;
        }
    }
    _markForCheck() {
        this.changeDetectorRef.markForCheck();
    }
}
LyRadio.decorators = [
    { type: Component, args: [{
                selector: 'ly-radio',
                styles: [":host { display: inline-block; } .ly-radio-input { pointer-events: none; opacity: 0; background: 0 0; position: absolute; width: 0; height: 0; } .ly-radio-label { cursor: pointer; white-space: nowrap; position: relative; display: inline-block; } .ly-radio-container { box-sizing: border-box; display: inline-block; position: relative; vertical-align: middle; height: calc(1em * 3); } .ly-radio-container .ly-radio-icon-container { width: 1.5em; height: 1.5em; } .ly-radio-input:checked ~ .ly-radio-container .ly-radio-inner-circle { transform: scale(0.6); } .ly-radio-input:checked ~ .ly-radio-container .ly-radio-outer-circle { border: solid 0.1em currentColor; color: currentColor !important; } .ly-radio-container .ly-radio-outer-circle, .ly-radio-container .ly-radio-inner-circle { transition: all 275ms cubic-bezier(0.4, 0, 0.2, 1) 0ms; position: absolute; border-radius: 100%; box-sizing: border-box; width: 1.25em; height: 1.25em; top: 0; left: 0; right: 0; bottom: 0; margin: auto; } .ly-radio-container .ly-radio-outer-circle { border: solid 1px currentColor; } .ly-radio-container .ly-radio-inner-circle { background: currentColor; transform: scale(0); } .ly-radio-label-content { display: inline-block; padding: 0 0.5em; } "],
                template: `
  <label #_labelContainer [attr.for]="inputId" class="ly-radio-label">
    <input
      class="ly-radio-input"
      [class.ly-radio-checked]="checked"
      [id]="inputId"
      [checked]="checked"
      [name]="name"
      (change)="_onInputChange($event)"
      type="radio"
      >
    <div #_ripple [color]="radioGroup.radioColor" class="ly-radio-container"
      lyRipple
      lyRippleCentered
      yRippleSensitive
      lyRippleRadius="containerSize"
    >
      <div class="ly-radio-icon-container">
      <div class="ly-radio-outer-circle" color="colorText"></div>
      <div class="ly-radio-inner-circle"></div>
      </div>
    </div>
    <div
    class="ly-radio-label-content"
    color="colorText">
      <ng-content></ng-content>
    </div>
  </label>
  `,
                changeDetection: ChangeDetectionStrategy.OnPush,
                preserveWhitespaces: false
            },] },
];
/** @nocollapse */
LyRadio.ctorParameters = () => [
    { type: LyRadioGroup, decorators: [{ type: Optional },] },
    { type: LyTheme, },
    { type: ChangeDetectorRef, },
    { type: NgZone, },
];
LyRadio.propDecorators = {
    "ripple": [{ type: ViewChild, args: [LyRipple,] },],
    "_labelContainer": [{ type: ViewChild, args: ['_labelContainer',] },],
    "onCheckedState": [{ type: Output },],
    "checked": [{ type: HostBinding, args: ['class.ly-radio-checked',] }, { type: Input },],
    "value": [{ type: Input },],
};
__decorate([
    IsBoolean(),
    __metadata("design:type", Boolean)
], LyRadio.prototype, "checked", void 0);
export class LyRadioModule {
}
LyRadioModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule, FormsModule, LyRippleModule, ThemeModule],
                exports: [LyRadioGroup, LyRadio],
                declarations: [LyRadioGroup, LyRadio],
            },] },
];
/** @nocollapse */
LyRadioModule.ctorParameters = () => [];
//# sourceMappingURL=radio.js.map