import { ChangeDetectorRef, OnChanges, AfterContentInit, AfterViewInit, OnInit, QueryList, EventEmitter, SimpleChanges, NgZone, ElementRef } from '@angular/core';
import { LyRipple } from 'alyle-ui/ripple-minimal';
import { ControlValueAccessor } from '@angular/forms';
import { LyTheme, LyStyleTheme } from 'alyle-ui/core';
export declare const LY_RADIO_CONTROL_VALUE_ACCESSOR: any;
export declare class LyRadioGroup implements AfterContentInit, AfterViewInit, ControlValueAccessor {
    private elementRef;
    theme: LyTheme;
    styleTheme: LyStyleTheme;
    ngZone: NgZone;
    private cd;
    _value: any;
    name: string;
    _color: string;
    value: any;
    radioColor: string;
    _radios: QueryList<LyRadio>;
    private changed;
    private touched;
    touch(): void;
    registerOnChange(fn: (value: any) => void): void;
    registerOnTouched(fn: () => void): void;
    constructor(elementRef: ElementRef, theme: LyTheme, styleTheme: LyStyleTheme, ngZone: NgZone, cd: ChangeDetectorRef);
    writeValue(value: any): void;
    ngAfterContentInit(): void;
    updatevalue(value: any): void;
    markForCheck(): void;
    ngAfterViewInit(): void;
}
export declare class LyRadio implements OnInit, AfterViewInit, OnChanges {
    radioGroup: LyRadioGroup;
    theme: LyTheme;
    private changeDetectorRef;
    private ngZone;
    id: string;
    name: string;
    _value: any;
    private _checked;
    ripple: LyRipple;
    _labelContainer: ElementRef;
    onCheckedState: EventEmitter<boolean>;
    checked: boolean;
    readonly inputId: string;
    value: any;
    _onInputChange(event: any): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    _markForCheck(): void;
    constructor(radioGroup: LyRadioGroup, theme: LyTheme, changeDetectorRef: ChangeDetectorRef, ngZone: NgZone);
}
export declare class LyRadioModule {
}
