/**
 * TODO: add resizing image
 */
import { ElementRef, ChangeDetectorRef, AfterContentInit, EventEmitter } from '@angular/core';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import { Observable } from 'rxjs/Observable';
export interface LyResizingCroppingImagesConfig {
    width: number;
    height: number;
    type?: string;
    output?: {
        width: number;
        height: number;
    } | ImageResolution;
}
export declare enum ImageResolution {
    /** Resizing & cropping */
    Default = 0,
    /** Only cropping */
    OriginalImage = 1,
}
export interface CroppedImage {
    base64Image: string;
    type: string;
}
export interface ImageState {
    isLoaded: boolean;
    isCrop: boolean;
}
export declare class LyResizingCroppingImages implements AfterContentInit {
    private elementRef;
    private cd;
    img: BehaviorSubject<HTMLImageElement>;
    result: string;
    fileName: string;
    private _img;
    private offset;
    private eventDirection;
    private scale;
    private _src;
    imgContainer: ElementRef;
    croppingContainer: ElementRef;
    src: string;
    format: string;
    config: LyResizingCroppingImagesConfig;
    isLoaded: boolean;
    isCropped: boolean;
    /** On loaded new image */
    loaded: EventEmitter<null>;
    /** On crop new image */
    cropped: EventEmitter<CroppedImage>;
    /** On error new image */
    error: EventEmitter<null>;
    private defaultType;
    private _dragData;
    dragData: Observable<{
        width: string;
        height: string;
        transform: string;
    }>;
    private zoomScale;
    constructor(elementRef: ElementRef, cd: ChangeDetectorRef);
    selectInputEvent(img: Event): void;
    fixedNum(num: number): number;
    setScale(size: number): void;
    private customCenter(width, height);
    /**
     * Ajustar a la pantalla
     */
    fitToScreen(): void;
    fit(): void;
    _moveStart(event: any): void;
    _move(event: any): void;
    private roundNumber(num);
    /**+ */
    zoomIn(): void;
    /**- */
    zoomOut(): void;
    ngAfterContentInit(): void;
    center(img?: HTMLImageElement): void;
    setImageUrl(src: string): void;
    private max(...values);
    private imageSmoothingQuality(img, config, quality);
    /**
     * Crop Image
     * Resizing & cropping image
     */
    crop(): CroppedImage;
    /**
     * Deprecated, use crop() instead
     */
    cropp(): string;
}
