(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('alyle-ui/core'), require('@angular/core'), require('rxjs/Observable'), require('rxjs/observable/fromEvent'), require('rxjs/observable/merge'), require('rxjs/add/observable/of'), require('rxjs/add/operator/filter'), require('rxjs/add/operator/map'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', 'alyle-ui/core', '@angular/core', 'rxjs/Observable', 'rxjs/observable/fromEvent', 'rxjs/observable/merge', 'rxjs/add/observable/of', 'rxjs/add/operator/filter', 'rxjs/add/operator/map', '@angular/common'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.responsive = {}),global.ly.core,global.ng.core,global.Rx,global.Rx.Observable,global.Rx.Observable,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.ng.common));
}(this, (function (exports,core,core$1,Observable,fromEvent,merge,of,filter,map,common) { 'use strict';

var Responsive = /** @class */ (function () {
    function Responsive(_ngZone, platformId) {
        this._ngZone = _ngZone;
        this.platformId = platformId;
    }
    Responsive.prototype.matchMedia = function (val) {
        return !core.Platform.isBrowser ? false : matchMedia(val).matches;
    };
    /**
     * return Observable<boolean>
     */
    /**
       * return Observable<boolean>
       */
    Responsive.prototype.observe = /**
       * return Observable<boolean>
       */
    function (value) {
        var _this = this;
        var mm = this.matchMedia(value);
        var mediaObservable = merge.merge(Observable.Observable.of(true), this.stateView());
        return mediaObservable
            .filter(function (state) {
            return _this.matchMedia(value) !== mm || state === true;
        })
            .map(function () {
            mm = _this.matchMedia(value);
            _this._registerMedia(value);
            return _this.matchMedia(value);
        });
    };
    Responsive.prototype._registerMedia = function (value) {
        Responsive._queryMap.set(value, this.matchMedia(value));
    };
    Responsive.prototype.stateView = function () {
        if (common.isPlatformBrowser(this.platformId)) {
            return this._ngZone.runOutsideAngular(function () {
                return fromEvent.fromEvent(window, 'resize');
            });
        }
        if (common.isPlatformServer(this.platformId)) {
            return Observable.Observable.of();
        }
    };
    Responsive._queryMap = new Map();
    Responsive.decorators = [
        { type: core$1.Injectable },
    ];
    /** @nocollapse */
    Responsive.ctorParameters = function () { return [
        { type: core$1.NgZone, },
        { type: Object, decorators: [{ type: core$1.Inject, args: [core$1.PLATFORM_ID,] },] },
    ]; };
    return Responsive;
}());

var MediaDirective = /** @class */ (function () {
    function MediaDirective(_viewContainer, templateRef, mediaService, platformId) {
        this._viewContainer = _viewContainer;
        this.mediaService = mediaService;
        this.platformId = platformId;
        this._TemplateRef = null;
        this._TemplateRef = templateRef;
    }
    Object.defineProperty(MediaDirective.prototype, "lyResponsive", {
        set: function (val) {
            this._media = val;
            this.updateView();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MediaDirective.prototype, "media", {
        get: function () {
            return this._media;
        },
        enumerable: true,
        configurable: true
    });
    MediaDirective.prototype.ngOnInit = function () {
        var _this = this;
        this.view = this.mediaService.stateView().subscribe(function () {
            _this.updateView();
        });
    };
    MediaDirective.prototype.updateView = function () {
        if (common.isPlatformServer(this.platformId) || this.mediaService.matchMedia(this._media)) {
            if (this._viewContainer.length === 0) {
                this._viewContainer.createEmbeddedView(this._TemplateRef);
            }
        }
        else if (this._viewContainer.length !== 0) {
            this._viewContainer.clear();
        }
    };
    MediaDirective.prototype.ngOnDestroy = function () {
        if (this.view) {
            this.view.unsubscribe();
        }
    };
    MediaDirective.decorators = [
        { type: core$1.Directive, args: [{
                    selector: '[lyResponsive]'
                },] },
    ];
    /** @nocollapse */
    MediaDirective.ctorParameters = function () { return [
        { type: core$1.ViewContainerRef, },
        { type: core$1.TemplateRef, },
        { type: Responsive, },
        { type: Object, decorators: [{ type: core$1.Inject, args: [core$1.PLATFORM_ID,] },] },
    ]; };
    MediaDirective.propDecorators = {
        "lyResponsive": [{ type: core$1.Input },],
    };
    return MediaDirective;
}());

function responsiveProviderFactory(parent, ngZone, platformId) {
    return parent || new Responsive(ngZone, platformId);
}
var responsiveProvider = {
    provide: Responsive,
    deps: [[new core$1.Optional(), new core$1.SkipSelf(), Responsive], core$1.NgZone, core$1.PLATFORM_ID],
    useFactory: responsiveProviderFactory
};
var ResponsiveModule = /** @class */ (function () {
    function ResponsiveModule() {
    }
    ResponsiveModule.decorators = [
        { type: core$1.NgModule, args: [{
                    declarations: [MediaDirective],
                    exports: [MediaDirective],
                    providers: [responsiveProvider]
                },] },
    ];
    /** @nocollapse */
    ResponsiveModule.ctorParameters = function () { return []; };
    return ResponsiveModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.Responsive = Responsive;
exports.MediaDirective = MediaDirective;
exports.responsiveProviderFactory = responsiveProviderFactory;
exports.responsiveProvider = responsiveProvider;
exports.ResponsiveModule = ResponsiveModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__responsive.umd.js.map
