import { Platform } from 'alyle-ui/core';
import { Injectable, NgZone, Inject } from '@angular/core';
import { Observable } from 'rxjs/Observable';
import { fromEvent } from 'rxjs/observable/fromEvent';
import { merge } from 'rxjs/observable/merge';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/filter';
import 'rxjs/add/operator/map';
import { PLATFORM_ID } from '@angular/core';
import { isPlatformBrowser, isPlatformServer } from '@angular/common';
export class Responsive {
    constructor(_ngZone, platformId) {
        this._ngZone = _ngZone;
        this.platformId = platformId;
    }
    matchMedia(val) {
        return !Platform.isBrowser ? false : matchMedia(val).matches;
    }
    /**
       * return Observable<boolean>
       */
    observe(value) {
        let mm = this.matchMedia(value);
        const mediaObservable = merge(Observable.of(true), this.stateView());
        return mediaObservable
            .filter((state) => {
            return this.matchMedia(value) !== mm || state === true;
        })
            .map(() => {
            mm = this.matchMedia(value);
            this._registerMedia(value);
            return this.matchMedia(value);
        });
    }
    _registerMedia(value) {
        Responsive._queryMap.set(value, this.matchMedia(value));
    }
    stateView() {
        if (isPlatformBrowser(this.platformId)) {
            return this._ngZone.runOutsideAngular(() => {
                return fromEvent(window, 'resize');
            });
        }
        if (isPlatformServer(this.platformId)) {
            return Observable.of();
        }
    }
}
Responsive._queryMap = new Map();
Responsive.decorators = [
    { type: Injectable },
];
/** @nocollapse */
Responsive.ctorParameters = () => [
    { type: NgZone, },
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] },] },
];
//# sourceMappingURL=media.service.js.map