import { Directive, Input, TemplateRef, ViewContainerRef, Inject } from '@angular/core';
import { PLATFORM_ID } from '@angular/core';
import { isPlatformServer } from '@angular/common';
import { Responsive } from '../media.service';
export class MediaDirective {
    constructor(_viewContainer, templateRef, mediaService, platformId) {
        this._viewContainer = _viewContainer;
        this.mediaService = mediaService;
        this.platformId = platformId;
        this._TemplateRef = null;
        this._TemplateRef = templateRef;
    }
    set lyResponsive(val) {
        this._media = val;
        this.updateView();
    }
    get media() {
        return this._media;
    }
    ngOnInit() {
        this.view = this.mediaService.stateView().subscribe(() => {
            this.updateView();
        });
    }
    updateView() {
        if (isPlatformServer(this.platformId) || this.mediaService.matchMedia(this._media)) {
            if (this._viewContainer.length === 0) {
                this._viewContainer.createEmbeddedView(this._TemplateRef);
            }
        }
        else if (this._viewContainer.length !== 0) {
            this._viewContainer.clear();
        }
    }
    ngOnDestroy() {
        if (this.view) {
            this.view.unsubscribe();
        }
    }
}
MediaDirective.decorators = [
    { type: Directive, args: [{
                selector: '[lyResponsive]'
            },] },
];
/** @nocollapse */
MediaDirective.ctorParameters = () => [
    { type: ViewContainerRef, },
    { type: TemplateRef, },
    { type: Responsive, },
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] },] },
];
MediaDirective.propDecorators = {
    "lyResponsive": [{ type: Input },],
};
//# sourceMappingURL=media.directive.js.map