import { NgZone, Renderer2 } from '@angular/core';
import { RippleConfig } from './ripple';
export interface RippleConfig {
    centered?: boolean;
    disabled?: boolean;
    sensitive?: boolean;
    radius?: 'containerSize' | number;
    percentageToIncrease?: number;
}
export declare class RippleRef {
    state: boolean;
    timestamp: number;
    readonly container: HTMLElement;
    end(): void;
}
export declare class Ripple {
    private _renderer;
    private _ngZone;
    private _hostElement;
    private _rippleRef;
    private _state;
    private _triggerElement;
    private _eventHandlers;
    rippleConfig: RippleConfig;
    private _transitionDuration;
    constructor(_elementRef: HTMLElement, _renderer: Renderer2, _ngZone: NgZone);
    private readonly _rectContainer;
    setContainerElement(element: HTMLElement | null): void;
    setTriggerElement(element: HTMLElement | null): void;
    private createRipple(styles);
    private onPointerDown(event);
    private onPointerLeave(event);
    startRipple(event: MouseEvent | PointerEvent, rippleConfig: RippleConfig): void;
    private runTimeoutOutsideZone(fn, delay?);
    endRipple(): void;
}
