import { ElementRef, NgZone, OnInit, OnDestroy, Renderer2, OnChanges, SimpleChanges } from '@angular/core';
import { Ripple, RippleConfig } from './ripple';
export declare class LyRipple implements OnInit, OnChanges, OnDestroy {
    private _platformId;
    private _elementRef;
    private _ngZone;
    private _renderer;
    rippleContainer: Ripple;
    private _containerElement;
    lyRippleCentered: boolean;
    lyRippleDisabled: boolean;
    lyRippleSensitive: boolean;
    lyRippleRadius: 'containerSize' | number;
    lyRipplePercentageToIncrease: number;
    readonly lyRippleConfig: RippleConfig;
    constructor(_platformId: Object, _elementRef: ElementRef, _ngZone: NgZone, _renderer: Renderer2);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    private _updateRipple();
    /**
     * Use only in ngAfterViewInit
     */
    setTriggerElement(triggerElement: HTMLElement): void;
    ngOnDestroy(): void;
}
