var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ElementRef, Input, Directive, NgZone, Renderer2, Inject, PLATFORM_ID } from '@angular/core';
import { IsBoolean, Platform } from 'alyle-ui/core';
import { Ripple } from './ripple';
var LyRipple = /** @class */ (function () {
    function LyRipple(_platformId, _elementRef, _ngZone, _renderer) {
        this._platformId = _platformId;
        this._elementRef = _elementRef;
        this._ngZone = _ngZone;
        this._renderer = _renderer;
        if (Platform.isBrowser) {
            this._containerElement = this._elementRef.nativeElement;
        }
    }
    Object.defineProperty(LyRipple.prototype, "lyRippleConfig", {
        get: function () {
            return {
                centered: this.lyRippleCentered,
                disabled: this.lyRippleDisabled,
                sensitive: this.lyRippleSensitive,
                radius: this.lyRippleRadius,
                percentageToIncrease: this.lyRipplePercentageToIncrease,
            };
        },
        enumerable: true,
        configurable: true
    });
    LyRipple.prototype.ngOnInit = function () {
        this._updateRipple();
    };
    LyRipple.prototype.ngOnChanges = function (changes) {
        this._updateRipple();
    };
    LyRipple.prototype._updateRipple = function () {
        if (Platform.isBrowser) {
            if (this.lyRippleConfig.disabled) {
                return;
            }
            if (!this.rippleContainer) {
                this.rippleContainer = new Ripple(this._containerElement, this._renderer, this._ngZone);
            }
            this.rippleContainer.rippleConfig = this.lyRippleConfig;
        }
    };
    /**
     * Use only in ngAfterViewInit
     */
    /**
       * Use only in ngAfterViewInit
       */
    LyRipple.prototype.setTriggerElement = /**
       * Use only in ngAfterViewInit
       */
    function (triggerElement) {
        this.lyRippleDisabled = true;
        this.rippleContainer.setTriggerElement(triggerElement);
        this.lyRippleDisabled = false;
    };
    LyRipple.prototype.ngOnDestroy = function () {
        if (this.rippleContainer) {
            this.rippleContainer.setTriggerElement(null);
        }
    };
    LyRipple.decorators = [
        { type: Directive, args: [{
                    selector: '[lyRipple]',
                    exportAs: 'lyRipple'
                },] },
    ];
    /** @nocollapse */
    LyRipple.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] },] },
        { type: ElementRef, },
        { type: NgZone, },
        { type: Renderer2, },
    ]; };
    LyRipple.propDecorators = {
        "lyRippleCentered": [{ type: Input },],
        "lyRippleDisabled": [{ type: Input },],
        "lyRippleSensitive": [{ type: Input },],
        "lyRippleRadius": [{ type: Input },],
        "lyRipplePercentageToIncrease": [{ type: Input },],
    };
    __decorate([
        IsBoolean(),
        __metadata("design:type", Boolean)
    ], LyRipple.prototype, "lyRippleCentered", void 0);
    __decorate([
        IsBoolean(),
        __metadata("design:type", Boolean)
    ], LyRipple.prototype, "lyRippleDisabled", void 0);
    __decorate([
        IsBoolean(),
        __metadata("design:type", Boolean)
    ], LyRipple.prototype, "lyRippleSensitive", void 0);
    return LyRipple;
}());
export { LyRipple };
//# sourceMappingURL=ripple.directive.js.map