(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('alyle-ui/core'), require('@angular/platform-browser'), require('chroma-js')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'alyle-ui/core', '@angular/platform-browser', 'chroma-js'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.shadow = {}),global.ng.core,global.ng.common,global.ly.core,global.ng.platformBrowser,global.chroma));
}(this, (function (exports,core,common,core$1,platformBrowser,_chroma) { 'use strict';

var chroma = _chroma;
var LyShadowService = /** @class */ (function () {
    function LyShadowService(sanitizer, platformId, theme) {
        this.sanitizer = sanitizer;
        this.platformId = platformId;
        this.theme = theme;
        /** Default elevation */
        this.elevation = 1;
    }
    /** demo: setShadow([elevation, color]) */
    /** demo: setShadow([elevation, color]) */
    LyShadowService.prototype.setShadow = /** demo: setShadow([elevation, color]) */
    function (elementRef, renderer, val, _lastClass) {
        var keys;
        var elevation;
        var color = 'colorShadow';
        if (val) {
            keys = val.join();
            elevation = val[0];
            color = val[1] || color;
        }
        else {
            keys = "" + this.elevation;
            elevation = this.elevation;
        }
        var newStyle = this.theme.createStyle("ly-" + keys, this._css.bind(this), elevation, color);
        this.theme.updateClass(elementRef, renderer, newStyle.id, _lastClass);
        return newStyle.id;
    };
    LyShadowService.prototype._css = function (elevation, color) {
        if (color === void 0) { color = ''; }
        return "" + core$1.shadowBuilder(elevation, this.theme.colorOf(color));
    };
    LyShadowService.prototype.shadow = function (color, size) {
        if (common.isPlatformBrowser(this.platformId)) {
            // const _color = chroma(converterToHex(chroma(color).css('hsl'))).get('rgba');
            // const _color = chroma(color).rgba();
            var opacity = chroma(color).alpha();
            var hex = chroma.mix('#fff', color, opacity).hex();
            var rgb = chroma(hex).rgb();
            var style = getShadow(size, rgb);
            // let style = `
            // rgba(${_color[0]}, ${_color[1]}, ${_color[2]}, ${
            //   ((70 / 100) * Number(size / 2))
            // }) 0px ${
            //   (((3 * size) - 2) / 2) * toPositiveNumber(sizeOrigin, true)
            // }px ${
            //   (3 * size * 2) / 2
            // }px 0px${
            //   ','
            // } rgba(${_color[0]}, ${_color[1]}, ${_color[2]}, ${
            //   ((60 / 100) * Number('0.' + String(size)))
            // }) 0px ${
            //   (((3 * size) - 2) / 3) * toPositiveNumber(sizeOrigin, true)
            // }px ${
            //   (3 * size * 2)
            // }px 0px${
            //   ','
            // } rgba(${_color[0]}, ${_color[1]}, ${_color[2]}, ${
            //   (40 / 100) * Number('0.' + String(size))
            // }) 0px ${
            //   (((3 * size) - 2)) * toPositiveNumber(sizeOrigin, true)
            // }px ${(3 * size * 2) / 1.4}px 0px`;
            // if (size < 2 && size > 0) {
            //   style = style + `, rgba(${_color[0]}, ${_color[1]}, ${_color[2]}, ${
            //     .23
            //   }) 0px ${2 * toPositiveNumber(sizeOrigin, true)}px 6px 0px`;
            // }
            return this.sanitizer.bypassSecurityTrustStyle(style);
        }
        else {
            return '';
        }
    };
    LyShadowService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    LyShadowService.ctorParameters = function () { return [
        { type: platformBrowser.DomSanitizer, },
        { type: undefined, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] },] },
        { type: core$1.LyTheme, },
    ]; };
    return LyShadowService;
}());
function getShadow(level, rgb) {
    var v = asfdtyd(1, 19, level), blur = asfdtyd(3, 38, level), opacity = asfdtyd(12, 30, level) / 100, v2 = asfdtyd(1, 15, level), blur2 = asfdtyd(2, 12, level), opacity2 = asfdtyd(24, 22, level) / 100, v3 = asfdtyd(1, 10, level), blur3 = asfdtyd(10, 38, level), size = asfdtyd(0, -7, level), opacity3 = asfdtyd(12, 32, level) / 100;
    return "0 " + v + "px " + blur + "px rgba(" + rgb.join() + "," + opacity + "), 0 " + v2 + "px " + blur2 + "px rgba(" + rgb.join() + "," + opacity2 + "), 0 " + v3 + "px " + blur3 + "px " + size + "px rgba(" + rgb.join() + "," + opacity3 + ")";
}
function asfdtyd(min, max, level) {
    var val = min;
    val += ((max - min) / 9) * (Math.abs(level) - 1);
    val *= Math.sign(level);
    return val;
}

var LyDeepComponent = /** @class */ (function () {
    function LyDeepComponent(elementRef, renderer, theme, shadow) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.theme = theme;
        this.shadow = shadow;
        this._size = 1;
        this._interval = 3000;
        this.numberState = -1;
        this._shadowColor = 'rgba(0,0,0,0.87)';
        /** Default elevation */
        this.elevation = 1;
    }
    Object.defineProperty(LyDeepComponent.prototype, "lyShadow", {
        set: function (val) {
            this.shadow.setShadow(this.elementRef, this.renderer, val, this._lastClass);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyDeepComponent.prototype, "shadowColor", {
        get: function () {
            return this._shadowColor;
        },
        set: function (val) {
            this._shadowColor = this.theme.colorOf(val);
            this.styleHost();
        },
        enumerable: true,
        configurable: true
    });
    LyDeepComponent.prototype.styleHost = function () {
        this.styleBoxShadow = this.shadow.shadow(this.shadowColor, this.scale);
    };
    Object.defineProperty(LyDeepComponent.prototype, "scale", {
        get: function () {
            return this._size;
        },
        set: function (val) {
            this._size = val;
            this.styleHost();
        },
        enumerable: true,
        configurable: true
    });
    LyDeepComponent.decorators = [
        { type: core.Directive, args: [{
                    selector: '[ly-deep], [ly-shadow], [lyShadow]'
                },] },
    ];
    /** @nocollapse */
    LyDeepComponent.ctorParameters = function () { return [
        { type: core.ElementRef, },
        { type: core.Renderer2, },
        { type: core$1.LyTheme, },
        { type: LyShadowService, },
    ]; };
    LyDeepComponent.propDecorators = {
        "styleBoxShadow": [{ type: core.HostBinding, args: ['style.box-shadow',] },],
        "lyShadow": [{ type: core.Input },],
        "shadowColor": [{ type: core.Input, args: ['shadowColor',] },],
        "scale": [{ type: core.Input },],
    };
    return LyDeepComponent;
}());

var LyShadowModule = /** @class */ (function () {
    function LyShadowModule() {
    }
    LyShadowModule.forRoot = function () {
        return {
            ngModule: LyShadowModule,
            providers: [LyShadowService],
        };
    };
    LyShadowModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [LyDeepComponent],
                    exports: [LyDeepComponent],
                    providers: [LyShadowService]
                },] },
    ];
    /** @nocollapse */
    LyShadowModule.ctorParameters = function () { return []; };
    return LyShadowModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.LyShadowService = LyShadowService;
exports.LyDeepComponent = LyDeepComponent;
exports.LyShadowModule = LyShadowModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__shadow.umd.js.map
