import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import 'rxjs/add/observable/of';
import 'rxjs/add/operator/map';
export class LySvgService {
    constructor(_http) {
        this._http = _http;
    }
    getSVG(url) {
        if (LySvgService._svg.has(url)) {
            return Promise.resolve(this._cloneSVG(LySvgService._svg.get(url)));
        }
        const req = this._http.get(url, { responseType: 'text' })
            .map((res) => {
            const svgEl = this._svgElementFromString(res);
            LySvgService._svg.set(url, svgEl);
            return this._cloneSVG(svgEl);
        })
            .toPromise();
        return req;
    }
    _svgElementFromString(str) {
        const div = document.createElement('DIV');
        div.innerHTML = str;
        const svg = div.querySelector('svg');
        if (!svg) {
            throw new Error('No SVG found in loaded contents');
        }
        return svg;
    }
    _cloneSVG(svg) {
        return svg.cloneNode(true);
    }
}
LySvgService._svg = new Map();
LySvgService.decorators = [
    { type: Injectable },
];
/** @nocollapse */
LySvgService.ctorParameters = () => [
    { type: HttpClient, },
];
//# sourceMappingURL=ly-svg.service.js.map