(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('alyle-ui/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'alyle-ui/core', '@angular/common'], factory) :
	(factory((global.alyleUi = global.alyleUi || {}, global.alyleUi.toolbar = {}),global.ng.core,global.ly.core,global.ng.common));
}(this, (function (exports,core,core$1,common) { 'use strict';

var ToolbarItem = /** @class */ (function () {
    function ToolbarItem() {
    }
    ToolbarItem.decorators = [
        { type: core.Directive, args: [{
                    selector: 'ly-toolbar-item',
                },] },
    ];
    /** @nocollapse */
    ToolbarItem.ctorParameters = function () { return []; };
    return ToolbarItem;
}());
var LyToolbar = /** @class */ (function () {
    function LyToolbar(theme) {
        this.theme = theme;
        /** Set default bg */
        this._bg = 'primary';
        /** set default color */
        this._color = 'main';
    }
    Object.defineProperty(LyToolbar.prototype, "toolbarBg", {
        set: function (val) {
            this._bg = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LyToolbar.prototype, "toolbarColor", {
        set: function (val) {
            this._color = val;
        },
        enumerable: true,
        configurable: true
    });
    LyToolbar.prototype.ngOnInit = function () {
        var _this = this;
        this._subscription = this.theme.palette.subscribe(function (colors) {
            _this.styleBackground = _this.theme.colorOf(_this._bg);
            _this.styleColor = _this.theme.colorOf(_this._color);
        });
    };
    LyToolbar.prototype.ngOnDestroy = function () {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    };
    LyToolbar.decorators = [
        { type: core.Component, args: [{
                    selector: 'ly-toolbar',
                    template: '<ng-content></ng-content>',
                    styles: [":host[ly-dense] { height: 48px; line-height: 48px; } :host { background: 0 0; margin: 0; max-width: 100%; width: 100%; min-height: 48px; height: 64px; box-sizing: border-box; display: flex; align-items: center; position: relative; font-size: 20px; } ",
                        ":host /deep/ ly-toolbar-item { font-weight: 400; vertical-align: middle; display: inline-block; overflow: hidden; text-overflow: ellipsis; white-space: nowrap; } :host /deep/ ly-toolbar-item[ly-toolbar-item-padding] { padding: 0 16px; } "],
                },] },
    ];
    /** @nocollapse */
    LyToolbar.ctorParameters = function () { return [
        { type: core$1.LyTheme, },
    ]; };
    LyToolbar.propDecorators = {
        "styleBackground": [{ type: core.HostBinding, args: ['style.background',] },],
        "styleColor": [{ type: core.HostBinding, args: ['style.color',] },],
        "toolbarBg": [{ type: core.Input },],
        "toolbarColor": [{ type: core.Input },],
    };
    return LyToolbar;
}());

var LyToolbarModule = /** @class */ (function () {
    function LyToolbarModule() {
    }
    LyToolbarModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    exports: [LyToolbar, ToolbarItem],
                    declarations: [LyToolbar, ToolbarItem],
                    providers: [core$1.LyStyleTheme]
                },] },
    ];
    /** @nocollapse */
    LyToolbarModule.ctorParameters = function () { return []; };
    return LyToolbarModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

exports.ToolbarItem = ToolbarItem;
exports.LyToolbar = LyToolbar;
exports.LyToolbarModule = LyToolbarModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=alyle-ui__toolbar.umd.js.map
