import { Component, Directive, Input, HostBinding } from '@angular/core';
import { LyTheme } from 'alyle-ui/core';
export class ToolbarItem {
}
ToolbarItem.decorators = [
    { type: Directive, args: [{
                selector: 'ly-toolbar-item',
            },] },
];
/** @nocollapse */
ToolbarItem.ctorParameters = () => [];
export class LyToolbar {
    constructor(theme) {
        this.theme = theme;
        /** Set default bg */
        this._bg = 'primary';
        /** set default color */
        this._color = 'main';
    }
    set toolbarBg(val) {
        this._bg = val;
    }
    set toolbarColor(val) {
        this._color = val;
    }
    ngOnInit() {
        this._subscription = this.theme.palette.subscribe((colors) => {
            this.styleBackground = this.theme.colorOf(this._bg);
            this.styleColor = this.theme.colorOf(this._color);
        });
    }
    ngOnDestroy() {
        if (this._subscription) {
            this._subscription.unsubscribe();
        }
    }
}
LyToolbar.decorators = [
    { type: Component, args: [{
                selector: 'ly-toolbar',
                template: '<ng-content></ng-content>',
                styles: [":host[ly-dense] { height: 48px; line-height: 48px; } :host { background: 0 0; margin: 0; max-width: 100%; width: 100%; min-height: 48px; height: 64px; box-sizing: border-box; display: flex; align-items: center; position: relative; font-size: 20px; } ",
                    ":host /deep/ ly-toolbar-item { font-weight: 400; vertical-align: middle; display: inline-block; overflow: hidden; text-overflow: ellipsis; white-space: nowrap; } :host /deep/ ly-toolbar-item[ly-toolbar-item-padding] { padding: 0 16px; } "],
            },] },
];
/** @nocollapse */
LyToolbar.ctorParameters = () => [
    { type: LyTheme, },
];
LyToolbar.propDecorators = {
    "styleBackground": [{ type: HostBinding, args: ['style.background',] },],
    "styleColor": [{ type: HostBinding, args: ['style.color',] },],
    "toolbarBg": [{ type: Input },],
    "toolbarColor": [{ type: Input },],
};
//# sourceMappingURL=toolbar.js.map